<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Tests\TestCase;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaHodnotenia;

/**
 * Class ZoznamPoctuKontrolPodlaHodnoteniaTest
 *
 * @package Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects
 */
class ZoznamPoctuKontrolPodlaHodnoteniaTest extends TestCase
{
    /**
     *
     */
    public function testInstance()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaHodnotenia();

        self::assertInstanceOf(ZoznamPoctuKontrolPodlaHodnotenia::class, $zoznam);
    }

    /**
     *
     */
    public function testAddInstanciaInejTriedy()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaHodnotenia();

        self::expectException(InvalidArgumentException::class);

        $zoznam->add(new PocetKontrolPodlaDruhu(
            DruhEmisnejKontrolyEnum::PRAVIDELNA(),
            11
        ));
    }

    /**
     *
     */
    public function testAddRovnakyDruhKontroly()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaHodnotenia();

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaHodnotenia = new PocetKontrolPodlaHodnotenia(
                HodnotenieEmisnejKontrolyEnum::SPOSOBILE(),
                33
            );

            $zoznam->add($pocetKontrolPodlaHodnotenia);
        }

        self::assertCount(1, $zoznam);

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaHodnotenia = new PocetKontrolPodlaHodnotenia(
                HodnotenieEmisnejKontrolyEnum::DOCASNE_SPOSOBILE(),
                3
            );

            $zoznam->add($pocetKontrolPodlaHodnotenia);
        }

        self::assertCount(2, $zoznam);

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaHodnotenia = new PocetKontrolPodlaHodnotenia(
                HodnotenieEmisnejKontrolyEnum::NESPOSOBILE(),
                3
            );

            $zoznam->add($pocetKontrolPodlaHodnotenia);
        }

        self::assertCount(3, $zoznam);

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaHodnotenia = new PocetKontrolPodlaHodnotenia(
                HodnotenieEmisnejKontrolyEnum::NEHODNOTENE(),
                3
            );

            $zoznam->add($pocetKontrolPodlaHodnotenia);
        }

        self::assertCount(4, $zoznam);
    }
}
